# this could actually be shined up to ID the part and set
# this variable accordingly
config flash SST49LF002A

# This flash needs byte accesses for programming
size 1

# see the help for the flash command to understand what it does
# it basically tells FS2 what it should treat as a flash region
# Note the bug workaround in the flash range below. It really 
# should stop at 0xffffffff. Bug should be fixed in next FS2
# version after 1.8.2.0
flash clear all
flash set 0xfffc0000..0xfffffffe
#flash set 0xfffc0000..0xffffffff

puts -nonewline "Erasing..."
# SST FWH parts need some extra poking to erase them
byte 0xffbc0002 0
flash erase sector 0xfffc0000
byte 0xffbc8002 0
flash erase sector 0xfffc8000
byte 0xffbd0002 0
flash erase sector 0xfffd0000
byte 0xffbd8002 0
flash erase sector 0xfffd8000
byte 0xffbe0002 0
flash erase sector 0xfffe0000
byte 0xffbe8002 0
flash erase sector 0xfffe8000
byte 0xffbf0002 0
flash erase sector 0xffff0000
byte 0xffbf8002 0
flash erase sector 0xffff8000
puts "done."

# now set up the full range for programming
flash clear all
flash set 0xfffc0000..0xffffffff

puts -nonewline "Programming..."
# and program the part
set result [load bin 0xfffc0000 W02000.rom]
puts "done."

puts -nonewline "Programmed "
puts -nonewline $result
puts " bytes."

# Clear the CMOS RAM that flashrom usually clears.
puts -nonewline "Clearing CMOS..."
for {set i 0x10} { $i < 0x80 } {incr i } {
	byte 0x70i $i; byte 0x71i 0x0
}
puts "done."


